// [[Rcpp::depends(RcppProgress)]]
#include <progress.hpp>
#include <progress_bar.hpp>
// [[Rcpp::export]]
double long_computation(int nb, bool display_progress=true) {
    double sum = 0;
    Progress p(nb*nb, display_progress);
    for (int i = 0; i < nb; ++i) {
        if (Progress::check_abort() )
            return -1.0;
        for (int j = 0; j < nb; ++j) {
            p.increment(); // update progress
            sum += R::dlnorm(i+j, 0.0, 1.0, 0);
        }
        // Rcpp::Rcout << "i = " << i << std::endl;    // this will flush into the stdout and destroy the presentation of progress bar
    }
    return sum + nb;
}
