dyn.unload(paste("sum1", .Platform$dynlib.ext, sep = ""))
system("R CMD SHLIB sum1.c")
dyn.load(paste("sum1", .Platform$dynlib.ext, sep = ""))

dyn.unload(paste("sum2", .Platform$dynlib.ext, sep = ""))
system("R CMD SHLIB sum2.c")
dyn.load(paste("sum2", .Platform$dynlib.ext, sep = ""))

dyn.unload(paste("sum3", .Platform$dynlib.ext, sep = ""))
system("R CMD SHLIB sum3.cpp")
dyn.load(paste("sum3", .Platform$dynlib.ext, sep = ""))

sum1r <- function(invec){
    .C("sum1c", 
       as.double(invec), 
       as.integer(length(invec)), 
       res = double(1))$res
}

sum2r <- function(invec){
    res <- .Call("sum2c", as.double(invec))
    return(res)
}


sum3r <- function(invec){
    .Call("sum_cpp", invec)
}

sum_foo <- function(invec){
    res <- 0
    for(i in 1 : length(invec)){
        res <- res + invec[i]
    }
    return(res)
}

library(Rcpp)
library(microbenchmark)
a <- rnorm(1000)
microbenchmark(sum_foo(a), sum1r(a), sum2r(a), sum3r(a), sum(a), times = 100)

a <- rnorm(10 ^ 7)
microbenchmark(sum_foo(a), sum1r(a), sum2r(a), sum3r(a), sum(a), times = 10)



dyn.unload(paste("sum1", .Platform$dynlib.ext, sep = ""))
dyn.unload(paste("sum2", .Platform$dynlib.ext, sep = ""))
dyn.unload(paste("sum3", .Platform$dynlib.ext, sep = ""))

